﻿'# Title    : SlimDX Font Mesh Demo
'# Author   : Sascha Bajus
'# Created  : 01/2009
'# Copyright © 2009 Sascha Bajus

'# Die Demo erstellt einen 3D Text aus dem Meshobject.
'# Der Text wird beleuchtet und rotiert timebased.


#Region "Copyright© Information (German)"
' Diese Software wird bereitgestellt "wie sie ist", ohne jegliche ausdrückliche oder 
' stillschweigende Gewährleistung. In keinem Fall kann der Author haftbar gemacht werden
' für Schäden, die aus der Nutzung dieser Software entstanden sind.
'
' Es ist erlaubt, diese Software für jeden Zweck zu nutzen, einschließlich der kommerziellen 
' Anwendungen, und sie zu verändern, vorbehaltlich der folgenden Einschränkungen: 
'
' 1. Der Ursprung dieser Software darf nicht falsch dargestellt werden; Sie dürfen nicht behaupten, 
'    dass Sie der Urheber der Original-Software sind. Wenn Sie diese Software in einem Produkt 

' 2. Altered-Source-Versionen müssen klar als solche gekennzeichnet, und dürfen nicht als 
'    Original-Software dargestellt werden.
'
' 3. Diese Informationen dürfen nicht entfernt oder geändert werden.
#End Region
#Region "Copyright© Information (English)"
' This software is provided 'as-is', without any express or implied warranty. In no event will 
' the authors be held liable for any damages arising from the use of this software.
'
' Permission is granted to anyone to use this software for any purpose, including commercial 
' applications, and to alter it and redistribute it freely, subject to the following restrictions:
'
' 1. The origin of this software must not be misrepresented; you must not claim that you wrote 
'    the original software. If you use this software in a product, an acknowledgment in the 
'    product documentation would be appreciated but is not required.
'
' 2. Altered source versions must be plainly marked as such, and must not be misrepresented 
'    as being the original software.
'
' 3. This notice may not be removed or altered from any source distribution.
'
#End Region



Imports SlimDX
Imports SlimDX.Direct3D9
Imports SlimDX.DirectInput
Imports sdxBaseEngine


Public Class Project : Inherits SDX9BaseEngine

    Private _fontMesh As Mesh 'Meshobject

    Public Sub New()

        AddHandler dxRenderScene, AddressOf render
        AddHandler dxKeyboardState, AddressOf keyboard
        'AddHandler dxMouseState, AddressOf Mouse
        AddHandler dxLoadObjectsSettings, AddressOf loading
        AddHandler dxEngineClosed, AddressOf ExitAplication
        '---------------------------------------------

        'dxEngine.KeyboardSetCooperativeLevel = CooperativeLevel.Exclusive Or CooperativeLevel.Foreground
        'dxEngine.MouseSetCooperativeLevel = CooperativeLevel.Exclusive Or CooperativeLevel.Foreground

        '#start Engine
        If dxEngine("SlimDX - BaseEngine - Font Mesh Demo") = False Then CloseBaseEngine()
    End Sub

#Region "Loading"
    Private Sub loading()
        '#create 3D font Mesh and set the Text
        _fontMesh = Mesh.CreateText(dxDevice, New System.Drawing.Font("Verdana", 26, FontStyle.Bold, GraphicsUnit.Pixel), "SlimDX", 1, 0.3)
        '#Setup Camposition
        dxCamera.currentPosition = New Vector3(0, 2, -8)
        '#Enable Z-Buffer
        dxZBuffer.Enabled = True
        '#setup Basic Light
        dxLightsFFP.EnableLighting = True
        dxLightsFFP.EnableDirectionalLight = True
        dxEngine.TargetBufferColor = Color.CornflowerBlue
    End Sub
#End Region
#Region "## render ##"
    Private Sub render()
        dxTransformWorld = dxMatrix.TimebasedRotationY(0.001) '#TimeBased rotation
        dxDevice.SetTexture(0, Nothing)
        dxLightsFFP.SetDefaultMaterial()
        _fontMesh.DrawSubset(0)  '#render 3D Text
        dx2DText.drawFPS()       '#render FPS
    End Sub
#End Region

#Region "## keyboard ##"
    Private Sub keyboard()
        '#Close Application and close all
        If dxEngine.KeyPressed(Key.Escape) Then CloseBaseEngine()
    End Sub
#End Region
#Region "## Exit Application ##"
    Private Sub ExitAplication()
        If Not _fontMesh Is Nothing Then _fontMesh.Dispose()
        If dxEngine.EngineError Then
            Me.Hide()
            MsgBox(dxEngine.EngineErrorDescription, MsgBoxStyle.Critical)
        End If
        End
    End Sub
#End Region

    Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Project))
        Me.SuspendLayout()
        '
        'Project
        '
        Me.ClientSize = New System.Drawing.Size(284, 262)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Project"
        Me.ResumeLayout(False)

    End Sub
End Class

